"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchResponse,
    avro_parse,
    load_schema,
)


class SearchDatasetsResponse(SearchResponse):
    """
    This is the response from `POST /datasets/search` expressed as JSON.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    _valueListName = "datasets"

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import ga4gh as ga4gh_3_1_0

        return {
            "datasets": ga4gh_3_1_0.Dataset,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import ga4gh as ga4gh_3_1_0
        from protocols.protocol_7_7 import ga4gh as ga4gh_3_1_0

        return {
            "org.ga4gh.models.Dataset": ga4gh_3_1_0.Dataset,
            "org.ga4gh.methods.SearchDatasetsResponse": ga4gh_3_1_0.SearchDatasetsResponse,
        }

    __slots__ = [
        "datasets",
        "nextPageToken",
    ]

    def __init__(
        self,
        datasets=list,
        nextPageToken=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_0.SearchDatasetsResponse model.

        :param datasets:
            The list of datasets.
        :type datasets: list[Dataset]
        :param nextPageToken:
            The continuation token, which is used to page through large result
            sets.   Provide this value in a subsequent request to
            return the next page of   results. This field will be
            empty if there aren't any additional results.
        :type nextPageToken: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.0"
